{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "dockerPull": "biowardrobe2/scidap-deseq:v0.0.5",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": "Rscript",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--count_matrix"
                    },
                    "id": "#DESeq2.cwl/count_matrix"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#DESeq2.cwl/input_script"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--metadata"
                    },
                    "id": "#DESeq2.cwl/metadata"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--threads"
                    },
                    "id": "#DESeq2.cwl/threads"
                }
            ],
            "id": "#DESeq2.cwl",
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.csv"
                    },
                    "id": "#DESeq2.cwl/DESeq2_out"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*DGE_res.csv"
                    },
                    "id": "#DESeq2.cwl/de_res"
                }
            ]
        },
        {
            "class": "ExpressionTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "File",
                        "Directory",
                        {
                            "type": "array",
                            "items": [
                                "File",
                                "Directory"
                            ]
                        }
                    ],
                    "id": "#folder.cwl/item"
                },
                {
                    "type": "string",
                    "id": "#folder.cwl/name"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "id": "#folder.cwl/out"
                }
            ],
            "expression": "${ if (inputs.item.class == 'Directory'){ return { 'out': { 'class': 'Directory', 'basename': inputs.name, 'listing': [inputs.item] } } }; if (inputs.item.class == 'File'){ var arr = [inputs.item]; } else { var arr = inputs.item; } return { 'out': { 'class': 'Directory', 'basename': inputs.name, 'listing': arr } } }",
            "id": "#folder.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "Rscript",
            "requirements": [
                {
                    "dockerPull": "filipejesus/tximport:3.8",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--gtf"
                    },
                    "id": "#salmon_count.cwl/gtf"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#salmon_count.cwl/input_script"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--metadata"
                    },
                    "id": "#salmon_count.cwl/metadata"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--salmon_dir"
                    },
                    "id": "#salmon_count.cwl/quant_results"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*gene_abundance_matrix*"
                    },
                    "id": "#salmon_count.cwl/gene_abundance_output"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*gene_count_matrix*"
                    },
                    "id": "#salmon_count.cwl/gene_count_output"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*gene_length_matrix*"
                    },
                    "id": "#salmon_count.cwl/gene_length_output"
                }
            ],
            "id": "#salmon_count.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "salmon",
            "requirements": [
                {
                    "dockerPull": "combinelab/salmon:0.12.0",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "arguments": [
                {
                    "position": -1,
                    "valueFrom": "quant"
                },
                {
                    "position": 0,
                    "valueFrom": "--validateMappings"
                },
                {
                    "position": 4,
                    "valueFrom": "A",
                    "prefix": "-l"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-1"
                    },
                    "id": "#salmon_quant.cwl/first_end_fastq"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i"
                    },
                    "id": "#salmon_quant.cwl/index_directory"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-o"
                    },
                    "id": "#salmon_quant.cwl/output"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 6,
                        "prefix": "-2"
                    },
                    "id": "#salmon_quant.cwl/second_end_fastq"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-r"
                    },
                    "id": "#salmon_quant.cwl/single_fastq"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-p"
                    },
                    "id": "#salmon_quant.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    },
                    "id": "#salmon_quant.cwl/salmon_out"
                }
            ],
            "id": "#salmon_quant.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/DESeq2_script"
                },
                {
                    "type": "File",
                    "id": "#main/annotation"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/fastq1"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/fastq2"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/fastq3"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/fastq4"
                },
                {
                    "type": "File",
                    "id": "#main/metadata"
                },
                {
                    "type": "File",
                    "id": "#main/salmon_count_script"
                },
                {
                    "type": "Directory",
                    "id": "#main/salmon_index"
                },
                {
                    "type": "string",
                    "id": "#main/subject_name1"
                },
                {
                    "type": "string",
                    "id": "#main/subject_name2"
                },
                {
                    "type": "string",
                    "id": "#main/subject_name3"
                },
                {
                    "type": "string",
                    "id": "#main/subject_name4"
                },
                {
                    "type": "int",
                    "id": "#main/threads"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputSource": "#main/DESeq2_folder/out",
                    "id": "#main/DESeq2_out"
                },
                {
                    "type": "Directory",
                    "outputSource": "#main/salmon_count_folder/out",
                    "id": "#main/salmon_count_out"
                },
                {
                    "type": "Directory",
                    "outputSource": "#main/salmon_quant_folder/out",
                    "id": "#main/salmon_quant_out"
                }
            ],
            "steps": [
                {
                    "run": "#DESeq2.cwl",
                    "in": [
                        {
                            "source": "#main/salmon_count/gene_count_output",
                            "id": "#main/DESeq2/count_matrix"
                        },
                        {
                            "source": "#main/DESeq2_script",
                            "id": "#main/DESeq2/input_script"
                        },
                        {
                            "source": "#main/metadata",
                            "id": "#main/DESeq2/metadata"
                        }
                    ],
                    "out": [
                        "#main/DESeq2/DESeq2_out"
                    ],
                    "id": "#main/DESeq2"
                },
                {
                    "run": "#folder.cwl",
                    "in": [
                        {
                            "source": "#main/DESeq2/DESeq2_out",
                            "id": "#main/DESeq2_folder/item"
                        },
                        {
                            "valueFrom": "DESeq2",
                            "id": "#main/DESeq2_folder/name"
                        }
                    ],
                    "out": [
                        "#main/DESeq2_folder/out"
                    ],
                    "id": "#main/DESeq2_folder"
                },
                {
                    "run": "#salmon_count.cwl",
                    "in": [
                        {
                            "source": "#main/annotation",
                            "id": "#main/salmon_count/gtf"
                        },
                        {
                            "source": "#main/salmon_count_script",
                            "id": "#main/salmon_count/input_script"
                        },
                        {
                            "source": "#main/metadata",
                            "id": "#main/salmon_count/metadata"
                        },
                        {
                            "source": "#main/salmon_quant_folder/out",
                            "id": "#main/salmon_count/quant_results"
                        }
                    ],
                    "out": [
                        "#main/salmon_count/gene_count_output",
                        "#main/salmon_count/gene_length_output",
                        "#main/salmon_count/gene_abundance_output"
                    ],
                    "id": "#main/salmon_count"
                },
                {
                    "run": "#folder.cwl",
                    "in": [
                        {
                            "source": [
                                "#main/salmon_count/gene_count_output",
                                "#main/salmon_count/gene_length_output",
                                "#main/salmon_count/gene_abundance_output"
                            ],
                            "id": "#main/salmon_count_folder/item"
                        },
                        {
                            "valueFrom": "salmon_count",
                            "id": "#main/salmon_count_folder/name"
                        }
                    ],
                    "out": [
                        "#main/salmon_count_folder/out"
                    ],
                    "id": "#main/salmon_count_folder"
                },
                {
                    "run": "#salmon_quant.cwl",
                    "in": [
                        {
                            "source": "#main/fastq1",
                            "valueFrom": "$(self[0])",
                            "id": "#main/salmon_quant_1/first_end_fastq"
                        },
                        {
                            "source": "#main/salmon_index",
                            "id": "#main/salmon_quant_1/index_directory"
                        },
                        {
                            "source": "#main/subject_name1",
                            "id": "#main/salmon_quant_1/output"
                        },
                        {
                            "source": "#main/fastq1",
                            "valueFrom": "$(self[1])",
                            "id": "#main/salmon_quant_1/second_end_fastq"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/salmon_quant_1/threads"
                        }
                    ],
                    "out": [
                        "#main/salmon_quant_1/salmon_out"
                    ],
                    "id": "#main/salmon_quant_1"
                },
                {
                    "run": "#salmon_quant.cwl",
                    "in": [
                        {
                            "source": "#main/fastq2",
                            "valueFrom": "$(self[0])",
                            "id": "#main/salmon_quant_2/first_end_fastq"
                        },
                        {
                            "source": "#main/salmon_index",
                            "id": "#main/salmon_quant_2/index_directory"
                        },
                        {
                            "source": "#main/subject_name2",
                            "id": "#main/salmon_quant_2/output"
                        },
                        {
                            "source": "#main/fastq2",
                            "valueFrom": "$(self[1])",
                            "id": "#main/salmon_quant_2/second_end_fastq"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/salmon_quant_2/threads"
                        }
                    ],
                    "out": [
                        "#main/salmon_quant_2/salmon_out"
                    ],
                    "id": "#main/salmon_quant_2"
                },
                {
                    "run": "#salmon_quant.cwl",
                    "in": [
                        {
                            "source": "#main/salmon_index",
                            "id": "#main/salmon_quant_3/index_directory"
                        },
                        {
                            "source": "#main/subject_name3",
                            "id": "#main/salmon_quant_3/output"
                        },
                        {
                            "source": "#main/fastq3",
                            "id": "#main/salmon_quant_3/single_fastq"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/salmon_quant_3/threads"
                        }
                    ],
                    "out": [
                        "#main/salmon_quant_3/salmon_out"
                    ],
                    "id": "#main/salmon_quant_3"
                },
                {
                    "run": "#salmon_quant.cwl",
                    "in": [
                        {
                            "source": "#main/salmon_index",
                            "id": "#main/salmon_quant_4/index_directory"
                        },
                        {
                            "source": "#main/subject_name4",
                            "id": "#main/salmon_quant_4/output"
                        },
                        {
                            "source": "#main/fastq4",
                            "id": "#main/salmon_quant_4/single_fastq"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/salmon_quant_4/threads"
                        }
                    ],
                    "out": [
                        "#main/salmon_quant_4/salmon_out"
                    ],
                    "id": "#main/salmon_quant_4"
                },
                {
                    "run": "#folder.cwl",
                    "in": [
                        {
                            "source": [
                                "#main/salmon_quant_1/salmon_out",
                                "#main/salmon_quant_2/salmon_out",
                                "#main/salmon_quant_3/salmon_out",
                                "#main/salmon_quant_4/salmon_out"
                            ],
                            "id": "#main/salmon_quant_folder/item"
                        },
                        {
                            "valueFrom": "salmon_quant",
                            "id": "#main/salmon_quant_folder/name"
                        }
                    ],
                    "out": [
                        "#main/salmon_quant_folder/out"
                    ],
                    "id": "#main/salmon_quant_folder"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
